/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.threevoid.trebuchet;

import com.threevoid.trebuchet.actors.Boundary;
import com.threevoid.trebuchet.actors.Projectile;
import com.threevoid.trebuchet.actors.Target;
import org.jbox2d.callbacks.ContactImpulse;
import org.jbox2d.callbacks.ContactListener;
import org.jbox2d.collision.Manifold;
import org.jbox2d.common.Vec2;
import org.jbox2d.dynamics.World;
import org.jbox2d.dynamics.contacts.Contact;

/**
 *
 * @author Max
 */
public class WorldHolder {
    private static World box2dworld;
    public final static float HeightInMetres = 20f;
    public final static float WidthInMetres = 50f;
    public final static float PixelsInMetre = 20f;
    
    public final static float timestep = 1.0f / 60.0f;
    public final static int velocityIterations = 8;
    public final static int positionIterations = 3;
    
    public static Boundary boundary;
    public static Projectile projectile;
    public static Target target;
    public static void create(){
        box2dworld = new World(new Vec2(0.0f, -12f), true);
        box2dworld.setContactListener(new ContactListener() {

            @Override
            public void beginContact(Contact cntct) {
                
                if((cntct.m_fixtureA.equals(WorldHolder.target.getFixture())&&
                        cntct.m_fixtureB.equals(WorldHolder.projectile.getFixture()))||(
                        cntct.m_fixtureA.equals(WorldHolder.projectile.getFixture())&&
                        cntct.m_fixtureB.equals(WorldHolder.target.getFixture())
                        )){
                    System.out.println("Hit Target");
                }
            }

            @Override
            public void endContact(Contact cntct) {
            }

            @Override
            public void preSolve(Contact cntct, Manifold mnfld) {
            }

            @Override
            public void postSolve(Contact cntct, ContactImpulse ci) {
            }
        });
        boundary = new Boundary();
        
        getBoundary().load();
    }
    public static World get(){
        return box2dworld;
    }
    
    public static void step(){
        box2dworld.step(timestep, velocityIterations, positionIterations);
    }
    
    public static Vec2 toScreenPosition(Vec2 worldPos){
        return new Vec2(toPixels(worldPos.x), toPixels(HeightInMetres)-toPixels(worldPos.y));
    }
    public static Vec2 toWorldPosition(Vec2 screenPos){
        return new Vec2(toMetres(screenPos.x), (toMetres(toPixels(HeightInMetres)-screenPos.y)));
    }
    public static float toPixels(float inMetres){
        return inMetres*PixelsInMetre;
    }
    
    public static float toMetres(float inPixels){
        return inPixels/PixelsInMetre;
    }

    /**
     * @return the boundary
     */
    public static Boundary getBoundary() {
        return boundary;
    }
}
