/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.threevoid.trebuchet.actors;

import com.threevoid.trebuchet.WorldHolder;
import org.jbox2d.collision.shapes.PolygonShape;
import org.jbox2d.common.Vec2;
import org.jbox2d.dynamics.Body;
import org.jbox2d.dynamics.BodyDef;
import org.jbox2d.dynamics.Fixture;
import org.jbox2d.dynamics.contacts.ContactEdge;
import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Rectangle;

/**
 *
 * @author Max
 */
public class Boundary {
    private Body bodyGround;
    private BodyDef bodyGroundDef;
    private PolygonShape b2polygonGround;
    private Rectangle drawRectangleGround;
    private Fixture groundFixture;
    
    private float groundHeightMetres = 2f;
    
    public void load(){
        bodyGroundDef = new BodyDef();
        bodyGroundDef.position = new Vec2(WorldHolder.WidthInMetres/2, groundHeightMetres/2);
        bodyGround = WorldHolder.get().createBody(bodyGroundDef);
        b2polygonGround = new PolygonShape();
        b2polygonGround.setAsBox(WorldHolder.WidthInMetres/2, groundHeightMetres/2);
        groundFixture = bodyGround.createFixture(b2polygonGround, 0.0f);
        
        BodyDef boundarydef = new BodyDef();
        boundarydef.position = new Vec2(0, 0);
        Body boundary = WorldHolder.get().createBody(boundarydef);
        PolygonShape walls = new PolygonShape();
        walls.setAsEdge(new Vec2(0,0), new Vec2(0, WorldHolder.HeightInMetres));
        boundary.createFixture(walls, 0f);
        walls.setAsEdge(new Vec2(WorldHolder.WidthInMetres,0), new Vec2(WorldHolder.WidthInMetres, WorldHolder.HeightInMetres));
        boundary.createFixture(walls, 0f);
        walls.setAsEdge(new Vec2(0 ,WorldHolder.HeightInMetres), new Vec2(WorldHolder.WidthInMetres, WorldHolder.HeightInMetres));
        boundary.createFixture(walls, 0f);        
                
        Vec2 screenPosTopLeft = WorldHolder.toScreenPosition(new Vec2(
                bodyGround.getPosition().x-(WorldHolder.WidthInMetres/2),
                bodyGround.getPosition().y+(groundHeightMetres/2))
                );
        drawRectangleGround = new Rectangle(
                screenPosTopLeft.x, 
                screenPosTopLeft.y,
                WorldHolder.toPixels(WorldHolder.WidthInMetres), 
                WorldHolder.toPixels(groundHeightMetres));
    }
    
    public boolean onGround(Body body){
        if(body.equals(bodyGround))return true;
        boolean onGround = false;
        ContactEdge edge = body.getContactList();
        while(edge!=null && !onGround){
            if(edge.contact.getFixtureA().equals(groundFixture)||
                    edge.contact.getFixtureA().equals(groundFixture)){
                onGround = true;
            }
            edge = edge.next;
        }
        return onGround;
    }
    public void draw(Graphics g){
//        g.setColor(Color.yellow);
//        g.draw(slickRectangle);
//        g.setColor(Color.green);
//        g.fill(slickRectangle);
//        g.setColor(Color.red);
//        System.out.println(""+WorldHolder.toPixels(body.getPosition().y));
//        g.setColor(Color.red);
//        Vec2 screenPos = WorldHolder.toScreenPosition(body.getPosition());
//        g.drawLine(screenPos.x, 
//                WorldHolder.toPixels(screenPos.y), 
//                WorldHolder.toPixels(WorldHolder.WidthInMetres),  
//                WorldHolder.toPixels(screenPos.y));
//        
        g.setColor(Color.blue);
        g.draw(drawRectangleGround);
//        Vec2[] vertices = b2polygon.getVertices();
//        Vec2 screenPos = WorldHolder.toScreenPosition(body.getPosition());
//        Vec2 previous = null;
//        for(Vec2 vec : vertices){
//            Vec2 vecsc = WorldHolder.toScreenPosition(new Vec2(vec.x+body.getPosition().x,
//                    vec.y+body.getPosition().y));
//            if(previous==null) {
//                previous = vecsc;
//                continue;
//            }
//            g.drawLine(previous.x, previous.y, vecsc.x, vecsc.y);
//            previous = vecsc;
//        }
//        g.setColor(Color.red);
//        g.drawLine(0f, screenPos.y+WorldHolder.toPixels(b2polygon.m_radius), 
//                WorldHolder.toPixels(WorldHolder.WidthInMetres),  screenPos.y+WorldHolder.toPixels(b2polygon.m_radius));
//        g.drawLine(0f, screenPos.y-WorldHolder.toPixels(b2polygon.m_radius), 
//                WorldHolder.toPixels(WorldHolder.WidthInMetres),  screenPos.y-WorldHolder.toPixels(b2polygon.m_radius));
        
    }
}
