/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.threevoid.trebuchet.actors;

import com.threevoid.trebuchet.WorldHolder;
import org.jbox2d.collision.shapes.CircleShape;
import org.jbox2d.common.Vec2;
import org.jbox2d.dynamics.Body;
import org.jbox2d.dynamics.BodyDef;
import org.jbox2d.dynamics.BodyType;
import org.jbox2d.dynamics.Fixture;
import org.jbox2d.dynamics.FixtureDef;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;

/**
 *
 * @author Max
 */
public class Projectile {
    private Body body;
    private BodyDef bodyDef;
    private FixtureDef fixtureDef; 
    private CircleShape b2circle;
    private Image sprite;
    private Fixture fixture;
    private float radius = 1.0f;
    
    
    public void load() throws SlickException{
        Image originalsprite = new Image("com/threevoid/trebuchet/assets/images/ball.png");
        int spriteDiam = originalsprite.getHeight();
        float scale = WorldHolder.toPixels(radius)/(spriteDiam/2f);
        sprite = originalsprite.getScaledCopy(scale);
        
        bodyDef = new BodyDef();
        bodyDef.position = new Vec2(5.0f, 15.0f);
        bodyDef.type = BodyType.DYNAMIC;
        bodyDef.linearDamping = 0f;
        bodyDef.angularDamping = 0.01f;
        bodyDef.fixedRotation = true;
        body = WorldHolder.get().createBody(bodyDef);
        b2circle = new CircleShape();
        b2circle.m_radius = 1.0f;
        fixtureDef = new FixtureDef();
        fixtureDef.shape = b2circle;
        fixtureDef.density = 1.0f;
        fixtureDef.friction = .1f;
        fixtureDef.restitution = 0.5f;
        fixture = body.createFixture(fixtureDef);
    }
    
    public Image getSprite(){
        return sprite;
    }
    public void left(int delta){
        body.applyForce(new Vec2(-3f*delta, 0f), body.getPosition());
        
    }
    public void right(int delta){
        body.applyForce(new Vec2(3f*delta, 0f), body.getPosition());
    }
    public void jump(){
        if(WorldHolder.getBoundary().onGround(body)){
            body.applyLinearImpulse(new Vec2(0f, 50f), body.getPosition());
        }
    }
    
    public void draw(Graphics g){
        Vec2 screenpostopleft = WorldHolder.toScreenPosition(new Vec2(
                body.getPosition().x-radius,
                body.getPosition().y+radius)
                );
        sprite.draw(screenpostopleft.x, screenpostopleft.y);
    }

    /**
     * @return the fixture
     */
    public Fixture getFixture() {
        return fixture;
    }
    
}
