/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.threevoid.trebuchet.actors;

import com.threevoid.trebuchet.WorldHolder;
import org.jbox2d.callbacks.ContactImpulse;
import org.jbox2d.callbacks.ContactListener;
import org.jbox2d.collision.Manifold;
import org.jbox2d.collision.shapes.CircleShape;
import org.jbox2d.common.Vec2;
import org.jbox2d.dynamics.Body;
import org.jbox2d.dynamics.BodyDef;
import org.jbox2d.dynamics.BodyType;
import org.jbox2d.dynamics.Fixture;
import org.jbox2d.dynamics.FixtureDef;
import org.jbox2d.dynamics.contacts.Contact;
import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;

/**
 *
 * @author Max
 */
public class Target extends Actor{
    private Body body;
    private BodyDef bodyDef;
    private FixtureDef fixtureDef; 
    private CircleShape b2circle;
    
    private Fixture fixture;
    private float radius = 2.0f;
    @Override
    public void load() {
        bodyDef = new BodyDef();
        bodyDef.position = new Vec2(15.0f, 15.0f);
        bodyDef.type = BodyType.KINEMATIC;
        body = WorldHolder.get().createBody(bodyDef);
        b2circle = new CircleShape();
        b2circle.m_radius = radius;
        fixtureDef = new FixtureDef();
        fixtureDef.shape = b2circle;
        fixtureDef.density = 1.0f;
        fixtureDef.friction = .1f;
        fixtureDef.restitution = 0.5f;
        fixture = body.createFixture(fixtureDef);
        
    }

    @Override
    public void draw(Graphics g) {
        Vec2 screenpostopleft = WorldHolder.toScreenPosition(new Vec2(
                body.getPosition().x-radius,
                body.getPosition().y+radius)
                );
        g.setColor(Color.red);
        g.fillOval(screenpostopleft.x, screenpostopleft.y, 
                WorldHolder.toPixels(radius*2), 
                WorldHolder.toPixels(radius*2));
    }

    /**
     * @return the fixture
     */
    public Fixture getFixture() {
        return fixture;
    }
    
}
